OpenGrok revision 872
0N/A#!/bin/sh
0N/A#
0N/A# OpenGrok Wrapper (initial setup and cron job updating)
0N/A#
0N/A# Supported Operating Systems:
0N/A# - Solaris 10 (SunOS 5.10)
0N/A# - OpenSolaris (SunOS 5.11)
0N/A# - Debian (Linux)
6983N/A#
6983N/A# Supported Deployment Engines
0N/A# - Tomcat 6
0N/A# - Glassfish
0N/A#
0N/A# Supported Environment Variables :
6983N/A# - OPENGROK_NON_INTERACTIVE Suppress Progress and Warnings Messages
6983N/A# - OPENGROK_STANDARD_ENV Run Time Shell Environment (Shell Script)
6983N/A# - OPENGROK_CONFIGURATION User Configuration (Shell Script)
6983N/A#
0N/A# Supported Environment Variables for configuring the default setup
0N/A# - OPENGROK_DISTRIBUTION_BASE Base Directory of the OpenGrok Distribution
0N/A# - OPENGROK_INSTANCE_BASE Base Directory of the OpenGrok User Data Area
0N/A# - EXUBERANT_CTAGS Full Path to Exuberant CTags
0N/A# - JAVA_HOME Full Path to Java Installation Root
4554N/A# - OPENGROK_APP_SERVER Application Server ("Tomcat" or "Glassfish")
7147N/A# - OPENGROK_WAR_TARGET_TOMCAT Tomcat Specific WAR Target Directory
0N/A# - OPENGROK_WAR_TARGET_GLASSFISH Glassfish Specific WAR Target Directory
1182N/A# - OPENGROK_WAR_TARGET Fallback WAR Target Directory
0N/A# - OPENGROK_TOMCAT_BASE Base Directory for Tomcat (contains webapps)
2N/A# - OPENGROK_GLASSFISH_BASE Base Directory for Glassfish (contains domains)
0N/A# - OPENGROK_GLASSFISH_DOMAIN Preferred Glassfish Domain Name
3853N/A# - OPENGROK_VERBOSE set any value to turn on verbosity from opengrok.jar
6678N/A# - OPENGROK_REMOTE_REPOS set to some value to enable history cache for remote repositories
0N/A#
7147N/A
7147N/A#
0N/A# Usage
0N/A#
0N/A
0N/AUsage()
3988N/A{
3853N/A echo 1>&2
0N/A echo "Usage: ${0} <deploy|update|updateQuietly|updateConfiguration|usage>" 1>&2
7147N/A echo " ${0} index [<directory>]" 1>&2
3853N/A echo 1>&2
3853N/A echo " Optional environment variables:" 1>&2
7147N/A echo " OPENGROK_CONFIGURATION - location of your configuartion" 1>&2
6678N/A echo " e.g. $ OPENGROK_CONFIGURATION=/var/opengrok/myog.conf ${0} ... " 1>&2
115N/A echo 1>&2
7147N/A echo " See the code for more information on configuration options / variables" 1>&2
3853N/A echo 1>&2
3853N/A exit 1
7147N/A}
3853N/A
3853N/A#
7147N/A# Runtime Configuration
3988N/A#
3988N/A
7147N/AOS_NAME="`/bin/uname -s`"
7147N/AOS_VERSION="`/bin/uname -r`"
3988N/A
3988N/A# TODO: Handle symlinks correctly (especially in ${0})
3988N/ASCRIPT_DIRECTORY="`dirname ${0}`"
3988N/ASCRIPT_DIRECTORY="`cd ${SCRIPT_DIRECTORY}; pwd`"
3988N/A
7147N/A#
7147N/A# Default Instance Configuration
7147N/A#
0N/A
0N/ADefaultInstanceConfiguration()
6208N/A{
3988N/A # Use the built-in defaults. This section can be copied to its own
3988N/A # file and tailored to your local requirements. Then simply set
3988N/A # OPENGROK_CONFIGURATION=/path/to/your/configuration, before using
3988N/A # this wrapper. It will save you hand editing in your settings
115N/A # on each new release. A sample cron(1M) entry might look like:
3988N/A # 15 0 * * * OPENGROK_CONFIGURATION=/pkgs/etc/OpenGrok.sh /pkgs/sbin/OpenGrok updateQuietly
3988N/A
7147N/A # Note: It is not really possible to ever provided defaults for
7147N/A # these values which will run in every UNIX-like environment.
6678N/A # So I have provided a set which are functional for a given
7147N/A # environment on which you can based you own configuration.
3853N/A
3853N/A # This has been updated to support more environment variables and
3853N/A # operating systems, if you have any reasonably generic
3853N/A # improvements please feel free to submit a patch.
6334N/A
6334N/A OPENGROK_INSTANCE_BASE="${OPENGROK_INSTANCE_BASE:-/var/opengrok}"
115N/A
6678N/A LOGGER_CONFIG_FILE="logging.properties"
3988N/A
115N/A if [ -z "${OPENGROK_DISTRIBUTION_BASE}" ]
6678N/A then
115N/A if [ -d "${SCRIPT_DIRECTORY}/dist" -a \
3988N/A -f "${SCRIPT_DIRECTORY}/dist/opengrok.jar" -a \
3853N/A -f "${SCRIPT_DIRECTORY}/dist/source.war" \
6678N/A ]
115N/A then
115N/A # Handle Developer Build Environments
115N/A OPENGROK_DISTRIBUTION_BASE="${SCRIPT_DIRECTORY}/dist"
6678N/A LOGGER_CONF_SOURCE="${SCRIPT_DIRECTORY}/conf/${LOGGER_CONFIG_FILE}"
6678N/A else
0N/A # Handle Binary Distributions
6678N/A OPENGROK_DISTRIBUTION_BASE="${SCRIPT_DIRECTORY}"
0N/A LOGGER_CONF_SOURCE="${OPENGROK_DISTRIBUTION_BASE}/doc/${LOGGER_CONFIG_FILE}"
6678N/A fi
0N/A fi
0N/A
0N/A # REQUIRED: Source Code/Repository Root
0N/A # (your source code or the root of all repositories)
1183N/A SRC_ROOT="${OPENGROK_INSTANCE_BASE}/src"
0N/A
0N/A # REQUIRED: OpenGrok Generate Data Root
0N/A # (for Lucene index and hypertext cross-references)
0N/A # This area is rebuilt by "update" / "updateQuietly"
0N/A DATA_ROOT="${OPENGROK_INSTANCE_BASE}/data"
0N/A
0N/A # OPTIONAL: User Provided Source Path to Description Mapping (Tab Separated Value)
0N/A # (The user maintained source of the generated EftarFile file)
0N/A PATH_DESC="${OPENGROK_INSTANCE_BASE}/etc/paths.tsv"
0N/A
3853N/A # REQUIRED: XML Configuration
3853N/A # (the configuration used by Web/GUI interfaces)
3853N/A XML_CONFIGURATION="${OPENGROK_INSTANCE_BASE}/etc/configuration.xml"
0N/A
3853N/A # TODO: Verify that Logger Configuration is REQUIRED and not OPTIONAL
0N/A # REQUIRED: Logger Configuration
3853N/A LOGGER_CONFIG_PATH="${OPENGROK_INSTANCE_BASE}/${LOGGER_CONFIG_FILE}"
0N/A LOGGER_PROPERTIES="-Djava.util.logging.config.file=${LOGGER_CONFIG_PATH}"
0N/A
7147N/A # REQUIRED: Java Archive of OpenGrok (Installation Location)
0N/A OPENGROK_JAR="${OPENGROK_DISTRIBUTION_BASE}/opengrok.jar"
0N/A
0N/A # REQUIRED(deploy): Web Archive of OpenGrok (Distribution Location)
6208N/A # (user building from source code will find this and other key
6678N/A # files in the "dist" directory after the build is completed)
0N/A OPENGROK_DIST_WAR="${OPENGROK_DISTRIBUTION_BASE}/source.war"
0N/A
7147N/A # REQUIRED: Exuberant CTags (http://ctags.sf.net)
0N/A EXUBERANT_CTAGS="${EXUBERANT_CTAGS:-`FindExuberantCTags`}"
0N/A
0N/A # REQUIRED: Java Home
6678N/A JAVA_HOME="${JAVA_HOME:-`FindJavaHome`}"
0N/A export JAVA_HOME
0N/A
7147N/A # REQUIRED: Java Virtual Machine
6678N/A JAVA="${JAVA:-$JAVA_HOME/bin/java}"
3853N/A
0N/A # OPTIONAL: Ignore these patterns as names of files or directories
6678N/A #IGNORE_PATTERNS="-i dummy"
0N/A
0N/A # OPTIONAL: Enable Projects
3853N/A # (Every directory in SRC_ROOT is considered a separate project)
3853N/A ENABLE_PROJECTS="-P"
3853N/A
3853N/A # OPTIONAL: Scanning Options (for Mercurial repositories)
3853N/A SCAN_FOR_REPOSITORY="-S"
3853N/A
3853N/A # OPTIONAL: Remote Repository Support (CVS or SVN)
3853N/A # (Can be very time demanding, uncomment if needed)
3853N/A #REMOTE_REPOSITORIES="-r on"
3853N/A if [ ! -z ${OPENGROK_REMOTE_REPOS} ]
3853N/A then
3853N/A REMOTE_REPOSITORIES="-r on"
3853N/A fi
3853N/A
3853N/A # OPTIONAL: Allow Leading Wildcard Searches
3853N/A # (default: off)
3853N/A #LEADING_WILDCARD="-a on"
3853N/A
3853N/A # OPTIONAL: Web Site Look & Feel
3853N/A # (Options: default, offwhite and polished.
3853N/A # Note the quoting requirements)
3853N/A #SKIN='-L "default"'
3853N/A
3853N/A # OPTIONAL: Set Maximum Indexed Words Per File
3853N/A # Note, that you might run out of memory, then either increase JVM memory
3853N/A # as noted in JAVA_OPTS, or set this limit(if you don't mind opengrok not
3853N/A # indexing the rest of the file, once the limit is reached)
3853N/A # (default: unlimited)
3853N/A #MAX_INDEXED_WORDS="-m 100000"
3853N/A MAX_INDEXED_WORDS="-m 10000"
3853N/A
3853N/A # OPTIONAL: Configuration Address (host:port)
3853N/A # (conf/web.xml default is localhost:2424)
3853N/A WEBAPP_CONFIG_ADDRESS="-U localhost:2424"
3853N/A
3853N/A # OPTIONAL: JVM Options
3853N/A #JAVA_OPTS="-server -Xmx1024m"
3853N/A
3853N/A # OPTIONAL: Full Path to History Utilities
3853N/A HG="`Which hg`"
3853N/A CVS="`Which cvs`"
3853N/A SVN="`Which svn`"
3853N/A SCCS="`Which sccs`"
3853N/A
3853N/A # OPTIONAL: Override Built-in Properties
3853N/A # Assumption: We should not set properties to the empty string
3853N/A PROPERTIES="\
115N/A${HG:+-Dorg.opensolaris.opengrok.history.Mercurial=$HG} \
3823N/A${CVS:+-Dorg.opensolaris.opengrok.history.cvs=$CVS} \
3823N/A${SVN:+-Dorg.opensolaris.opengrok.history.Subversion=$SVN} \
3823N/A${SCCS:+-Dorg.opensolaris.opengrok.history.SCCS=$SCCS} \
3823N/A"
3823N/A
3823N/A # OPTIONAL: Store The History Cache in Java DB (derby),
3988N/A # instead of file system (in gzipped xml files).
3988N/A #
3988N/A # Requirements:
3988N/A # - derbyclient.jar - See README.txt for more details
3988N/A # - Running Derby Server - Defaults to localhost:1527
3988N/A #
3988N/A #DERBY_HISTORY_CACHE=-D
3988N/A
3988N/A # DELIVERED: An update program for EftarFile
7147N/A # Usage: <class> inputFile [inputFile ...] outputFile
7147N/A # EftarFile == An Extremely Fast Tagged Attribute Read-only File System
7147N/A EFTAR_UPDATE="org.opensolaris.opengrok.web.EftarFile"
3988N/A
7147N/A # HARDCODED: Generated EftarFile (See web/*.jsp)
3988N/A EFTAR_OUTPUT_FILE="${DATA_ROOT}/index/dtags.eftar"
7147N/A
7147N/A # Be Quiet? (set indirectly by command line arguments in the main program)
7150N/A #QUIET=""
7150N/A
7150N/A # or alternatively, Be Verbose!
7150N/A #VERBOSE="-v"
7150N/A if [ ! -z ${OPENGROK_VERBOSE} ]
7150N/A then
7147N/A VERBOSE=-v
3988N/A fi
3988N/A}
3988N/A
3988N/A#
3988N/A# Helper Functions - Logging
7147N/A#
7147N/A# In general, non-interactive use like cron jobs and automated
7147N/A# installation environments should not generate unnecessary
7147N/A# progress information or warnings, as usage and configuration
3988N/A# will have generally been debugged prior to automation.
7147N/A#
7147N/A
3988N/AProgress()
3988N/A{
6678N/A if [ -z "${OPENGROK_NON_INTERACTIVE}" ]
3988N/A then
3988N/A echo "${@}"
7147N/A fi
7147N/A}
7147N/A
3988N/AWarning()
7147N/A{
7147N/A if [ -z "${OPENGROK_NON_INTERACTIVE}" ]
3988N/A then
7147N/A echo "WARNING: ${@}" 1>&2
7147N/A fi
7147N/A}
7147N/A
7147N/AError()
3988N/A{
3988N/A echo "ERROR: ${@}" 1>&2
3988N/A}
6334N/A
6334N/AFatalError()
6334N/A{
6334N/A echo 1>&2
6334N/A echo "FATAL ERROR: ${@} - Aborting!" 1>&2
7147N/A echo 1>&2
6334N/A ${DO} exit 2
6334N/A}
6334N/A
6334N/A#
6334N/A# Helper Functions - Autodetection of Runtime Environment
6334N/A#
6334N/A
6334N/AWhich()
6334N/A{
3988N/A path="`which ${1} 2>/dev/null`"
3988N/A
3988N/A if [ -x "${path}" ]
6334N/A then
3988N/A echo "${path}"
7147N/A fi
7147N/A}
7150N/A
7147N/AFindExuberantCTags()
3988N/A{
3988N/A case "${OS_NAME}:${OS_VERSION}" in
3988N/A SunOS:5.10) commandName="" ;;
3988N/A SunOS:5.11) commandName="exctags" ;;
3988N/A Linux:*) commandName="ctags-exuberant" ;;
3988N/A *) commandName="" ;;
3988N/A esac
3988N/A
3988N/A if [ -z "${commandName}" ]
3988N/A then
3988N/A Error "Unable to determine Exuberant CTags command name" \
7196N/A "for ${OS_NAME} ${OS_VERSION}"
7196N/A return
7196N/A fi
7196N/A
7196N/A Which "${commandName}"
7196N/A}
7196N/A
7196N/AFindJavaHome()
7196N/A{
7196N/A case "${OS_NAME}:${OS_VERSION}" in
0N/A SunOS:5.10) javaHome="/usr/jdk/instances/jdk1.6.0" ;;
SunOS:5.11) javaHome="/usr/jdk/latest" ;;
Linux:*) javaHome="/usr/lib/jvm/java-6-sun" ;;
*) javaHome="" ;;
esac
if [ -z "${javaHome}" ]
then
Error "Unable to determine Java 6 Home" \
"for ${OS_NAME} ${OS_VERSION}"
return
fi
if [ ! -d "${javaHome}" ]
then
Error "Missing Java Home ${javaHome}"
return
fi
echo "${javaHome}"
}
FindApplicationServerType()
{
# Use this function to determine which environment the deploy the
# web application function into. Some users (especially
# developers) will have many deployment environments or will wish
# to specify directly the application server to deploy to.
# Either use the environment variable OPENGROK_APP_SERVER or
# reimplement this function in your configuration file (as
# specified by OPENGROK_CONFIGURATION)
if [ -n "${OPENGROK_APP_SERVER}" ]
then
echo "${OPENGROK_APP_SERVER}"
return
fi
# This implementation favours Tomcat, but needs a lot of work,
# especially if Glassfish is perferrerd or it is under the control
# of SMF (Service Management Facility)
# Maybe a better implementation would be to call Application
# Server specific WAR Directory and see if they exist.
if [ -d "/var/tomcat6/webapps" \
-o -d "/var/lib/tomcat6/webapps" \
]
then
echo "Tomcat"
return
fi
if [ -x "/etc/init.d/appserv" -a -d "/var/appserver/domains" ]
then
echo "Glassfish"
return
fi
# Assume Tomcat
echo "Tomcat"
}
DetermineWarDirectoryTomcat()
{
if [ -n "${OPENGROK_WAR_TARGET_TOMCAT}" ]
then
echo "${OPENGROK_WAR_TARGET_TOMCAT}"
return
elif [ -n "${OPENGROK_WAR_TARGET}" ]
then
echo "${OPENGROK_WAR_TARGET}"
return
fi
for prefix in \
${OPENGROK_TOMCAT_BASE} \
/var/tomcat6 \
/var/lib/tomcat6 \
do
if [ -d "${prefix}/webapps" ]
then
echo "${prefix}/webapps"
return
fi
done
}
DetermineWarDirectoryGlassfish()
{
if [ -n "${OPENGROK_WAR_TARGET_GLASSFISH}" ]
then
echo "${OPENGROK_WAR_TARGET_GLASSFISH}"
return
elif [ -n "${OPENGROK_WAR_TARGET}" ]
then
echo "${OPENGROK_WAR_TARGET}"
return
fi
for prefix in \
${OPENGROK_GLASSFISH_BASE} \
/var/appserver \
do
if [ -d "${prefix}/domains" ]
then
if [ -z "${domainDirectory}" ]
then
domainDirectory="${prefix}/domains"
fi
fi
done
if [ -z "${domainDirectory}" ]
then
return
fi
# User Specified Domain
if [ -n "${OPENGROK_GLASSFISH_DOMAIN}" ]
then
directory="${domainDirectory}/${OPENGROK_GLASSFISH_DOMAIN}/autodeploy"
if [ ! -d "${directory}" ]
then
FatalError "Missing Specified Glassfish Domain ${OPENGROK_GLASSFISH_DOMAIN}"
fi
echo "${directory}"
return
fi
# Arbitrary Domain Selection
firstDomain=`ls -1 ${domainDirectory} | head -1`
if [ -z "${firstDomain}" ]
then
FatalError "Failed to dynamically determine Glassfish Domain from ${domainDirectory}"
fi
echo "${domainDirectory}/${firstDomain}/autodeploy"
}
#
# Implementation
#
# The variable "DO" can usefully be set to "echo" to aid in script debugging
#
LoadStandardEnvironment()
{
# Setup a standard execution environment (if required)
OPENGROK_STANDARD_ENV="${OPENGROK_STANDARD_ENV:-/pkgs/sbin/CronExecutionEnvironment.sh}"
if [ -f "${OPENGROK_STANDARD_ENV}" ]
then
Progress "Loading ${OPENGROK_STANDARD_ENV} ..."
. "${OPENGROK_STANDARD_ENV}"
fi
}
LoadInstanceConfiguration()
{
# Note: As all functions have been defined by the time this routine
# is called, your configuration can, if desired, override functions
# in addition to setting the variables mentioned in the function
# DefaultInstanceConfiguration(), this maybe useful to override
# functionality used to determine the default deployment environment
# find dependencies or validate the configuration, for example.
if [ -n "${OPENGROK_CONFIGURATION}" -a -f "${OPENGROK_CONFIGURATION}" ]
then
# Load the Local OpenGrok Configuration Environment
Progress "Loading ${OPENGROK_CONFIGURATION} ..."
. "${OPENGROK_CONFIGURATION}"
else
Progress "Loading the default instance configuration ..."
DefaultInstanceConfiguration
fi
}
ValidateConfiguration()
{
if [ ! -x "${EXUBERANT_CTAGS}" ]
then
FatalError "Missing Dependent Application - Exuberant CTags"
fi
if [ ! -d "${SRC_ROOT}" ]
then
FatalError "OpenGrok Source Path ${SRC_ROOT} doesn't exist"
fi
}
CreateRuntimeRequirements()
{
if [ ! -d "${DATA_ROOT}" ]
then
Warning "OpenGrok Generated Data Path ${DATA_ROOT} doesn't exist"
Progress " Attempting to create generated data directory ... "
${DO} mkdir -p "${DATA_ROOT}"
fi
if [ ! -d "${DATA_ROOT}" ]
then
FatalError "OpenGrok Data Path ${DATA_ROOT} doesn't exist"
fi
if [ ! -d "${OPENGROK_INSTANCE_BASE}/etc" ]
then
Warning "OpenGrok Generated Etc Path ${OPENGROK_INSTANCE_BASE}/etc doesn't exist"
Progress " Attempting to create generated etc directory ... "
${DO} mkdir -p "${OPENGROK_INSTANCE_BASE}/etc"
fi
if [ ! -d "${OPENGROK_INSTANCE_BASE}/etc" ]
then
FatalError "OpenGrok Etc Path ${OPENGROK_INSTANCE_BASE}/etc doesn't exist"
fi
if [ -n "${LOGGER_CONFIG_PATH}" -a ! -f "${LOGGER_CONFIG_PATH}" ]
then
Progress " Creating default ${LOGGER_CONFIG_PATH} ... "
if [ ! -f "${LOGGER_CONF_SOURCE}" ]
then
FatalError "Can't find distribution logging configuration"
"(${LOGGER_CONF_SOURCE}) to install as default"
"logging configuration (${LOGGER_CONFIG_PATH})"
fi
${DO} cp "${LOGGER_CONF_SOURCE}" "${LOGGER_CONFIG_PATH}"
# TODO: Consider automatically setting the logging directory
# to within the instance base directory tree
fi
}
StdInvocation()
{
${DO} ${JAVA} ${JAVA_OPTS} ${PROPERTIES} \
${LOGGER_PROPERTIES} \
-jar ${OPENGROK_JAR} \
${IGNORE_PATTERNS} ${ENABLE_PROJECTS} \
${DERBY_HISTORY_CACHE} \
${SCAN_FOR_REPOSITORY} ${REMOTE_REPOSITORIES} \
${VERBOSE} ${QUIET} \
${EXUBERANT_CTAGS:+-c} ${EXUBERANT_CTAGS} \
${MAX_INDEXED_WORDS} ${SKIN} ${LEADING_WILDCARD} \
-W ${XML_CONFIGURATION} \
${WEBAPP_CONFIG_ADDRESS} \
-s ${SRC_ROOT} -d ${DATA_ROOT} \
"${@}"
#? -R ${XML_CONFIGURATION} \
}
UpdateGeneratedData()
{
StdInvocation -H
}
UpdateDescriptionCache()
{
# OPTIONAL : Update the EftarFile data
if [ -n "${PATH_DESC}" -a -s "${PATH_DESC}" ]
then
${DO} ${JAVA} -classpath ${OPENGROK_JAR} \
${EFTAR_UPDATE} ${PATH_DESC} ${EFTAR_OUTPUT_FILE}
fi
}
OpenGrokUsage()
{
echo "Options for opengrok.jar:" 1>&2
${DO} ${JAVA} ${JAVA_OPTS} -jar ${OPENGROK_JAR} '-?'
}
DeployWar()
{
applicationServer="`FindApplicationServerType`"
case "${applicationServer}" in
Tomcat) warTarget="`DetermineWarDirectoryTomcat`" ;;
Glassfish) warTarget="`DetermineWarDirectoryGlassfish`" ;;
*) FatalError "Unsupported Application Server ${applicationServer}" ;;
esac
if [ -z "${warTarget}" ]
then
FatalError "Unable to determine Deployment Directory for ${applicationServer}"
fi
if [ ! -f "${OPENGROK_DIST_WAR}" ]
then
FatalError "Missing Web Application Archive ${OPENGROK_DIST_WAR}"
fi
if [ ! -d "${warTarget}" ]
then
FatalError "Missing Deployment Directory ${warTarget}"
fi
Progress "Installing ${OPENGROK_DIST_WAR} to ${warTarget} ..."
${DO} cp "${OPENGROK_DIST_WAR}" "${warTarget}/"
if [ $? != 0 ]
then
FatalError "Web Application Installation FAILED"
fi
Progress
Progress "Start your application server (${applicationServer}), if it is not already"
Progress "running, or wait until it loads the just installed web application."
Progress
Progress "OpenGrok should be available on <HOST>:<PORT>/source"
Progress " where HOST and PORT are configured in ${applicationServer}."
Progress
}
#
# Main Program
#
if [ $# -eq 0 -o $# -gt 2 ]
then
Usage
fi
LoadStandardEnvironment
LoadInstanceConfiguration
case "${1}" in
deploy)
DeployWar
;;
update)
ValidateConfiguration
CreateRuntimeRequirements
UpdateGeneratedData
UpdateDescriptionCache
;;
updateQuietly)
ValidateConfiguration
CreateRuntimeRequirements
QUIET="-q"
VERBOSE=""
UpdateGeneratedData
UpdateDescriptionCache
;;
index)
if [ -n "${2}" ]
then
SRC_ROOT="${2}"
fi
ValidateConfiguration
CreateRuntimeRequirements
UpdateGeneratedData
UpdateDescriptionCache
;;
usage)
OpenGrokUsage
Usage
;;
*)
Usage
;;
esac
#
# End of File
#